// tslint:disable-next-line:no-reference
/// <reference path="../../node_modules/reflect-metadata/index.d.ts" />
import { GraphQLScalarType, GraphQLString, GraphQLFloat, GraphQLBoolean, GraphQLList } from 'graphql';
export const GRAPHQL_SCALAR_TYPE = Symbol('graphql:scalar-type');
export function ScalarType(config = {}) {
    return target => {
        Reflect.defineMetadata(GRAPHQL_SCALAR_TYPE, new GraphQLScalarType(Object.assign({ name: target.name, parseValue: obj => Object.assign(Reflect.construct(target, []), obj), parseLiteral: obj => Object.assign(Reflect.construct(target, []), obj), serialize: instance => Object.assign({}, instance) }, (config || {}))), target);
    };
}
const DEFAULT_SCALAR_TYPE_MAP = new Map([
    [String, GraphQLString],
    [Number, GraphQLFloat],
    [Boolean, GraphQLBoolean],
]);
export function getScalarTypeFromClass(target) {
    if (target instanceof Array) {
        const elementType = getScalarTypeFromClass(target[0]);
        return elementType && new GraphQLList(elementType);
    }
    return DEFAULT_SCALAR_TYPE_MAP.get(target) || Reflect.getMetadata(GRAPHQL_SCALAR_TYPE, target);
}
//# sourceMappingURL=scalar-type.js.map