export function extractFieldResolversFromObjectType(objectType) {
    const fieldResolvers = {};
    const fieldMap = objectType.getFields();
    for (const fieldName in fieldMap) {
        const fieldDefinition = fieldMap[fieldName];
        if ('subscribe' in fieldDefinition) {
            fieldResolvers[fieldName] = {
                subscribe: fieldDefinition.subscribe,
            };
        }
        else if ('resolve' in fieldDefinition) {
            fieldResolvers[fieldName] = fieldDefinition.resolve;
        }
    }
    return fieldResolvers;
}
//# sourceMappingURL=extract-field-resolvers-from-object-type.js.map