import { GraphQLScalarType, GraphQLObjectType, GraphQLInterfaceType } from "graphql";
import { extractFieldResolversFromObjectType } from "./extract-field-resolvers-from-object-type";
export function extractResolversFromSchema(schema) {
    const resolvers = {};
    const typeMap = schema.getTypeMap();
    for (const typeName in typeMap) {
        const typeDef = typeMap[typeName];
        if (typeDef instanceof GraphQLScalarType) {
            resolvers[typeName] = typeDef;
        }
        else if (typeDef instanceof GraphQLObjectType || typeDef instanceof GraphQLInterfaceType) {
            resolvers[typeName] = extractFieldResolversFromObjectType(typeDef);
        }
    }
    return resolvers;
}
//# sourceMappingURL=extract-resolvers-from-schema.js.map