"use strict";
// tslint:disable-next-line:no-reference
/// <reference path="../../node_modules/reflect-metadata/index.d.ts" />
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const object_type_1 = require("./object-type");
function InterfaceType(config = {}) {
    return target => {
        const existingGraphQLObjectTypeQueue = Reflect.getMetadata(object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE, target) || [];
        existingGraphQLObjectTypeQueue.push(() => {
            const existingConfig = Reflect.getMetadata(object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG, target) || {};
            Reflect.defineMetadata(object_type_1.GRAPHQL_OBJECT_TYPE, new graphql_1.GraphQLInterfaceType(Object.assign({ name: config.name || target.name, resolveType: function (root, ...args) {
                    const fieldType = config.resolveType.call(root, root, ...args);
                    return object_type_1.getObjectTypeFromClass(fieldType) || fieldType;
                } }, existingConfig)), target);
        });
        Reflect.defineMetadata(object_type_1.GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE, existingGraphQLObjectTypeQueue, target);
        return target;
    };
}
exports.InterfaceType = InterfaceType;
//# sourceMappingURL=interface-type.js.map