import { GraphQLObjectType } from 'graphql';
import { Type, AnyType, MaybeArray } from './common';
export declare const GRAPHQL_OBJECT_TYPE_CONFIG: unique symbol;
export declare const GRAPHQL_OBJECT_TYPE: unique symbol;
export declare const GRAPHQL_OBJECT_TYPE_CONFIG_BUILD_QUEUE: unique symbol;
export declare function Arg(argumentName: string): ParameterDecorator;
export declare function Field<TSource, TContext, TArgs, TResult>(typeFactory?: (type: void) => Type<TResult> | GraphQLObjectType | AnyType | unknown): (target: TSource, propertyKey: string) => void;
export interface ObjectTypeDecoratorConfig<TResult> {
    name?: string;
    implements?: MaybeArray<Type<TResult> | GraphQLObjectType | AnyType | unknown>;
}
export declare function ObjectType<TSource, TResult, TContext>(config?: ObjectTypeDecoratorConfig<TResult>): ClassDecorator;
export declare function getObjectTypeFromClass<T>(target: Type<T> | unknown): any;
