"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
const extract_field_resolvers_from_object_type_1 = require("./extract-field-resolvers-from-object-type");
function extractResolversFromSchema(schema) {
    const resolvers = {};
    const typeMap = schema.getTypeMap();
    for (const typeName in typeMap) {
        const typeDef = typeMap[typeName];
        if (typeDef instanceof graphql_1.GraphQLScalarType) {
            resolvers[typeName] = typeDef;
        }
        else if (typeDef instanceof graphql_1.GraphQLObjectType || typeDef instanceof graphql_1.GraphQLInterfaceType) {
            resolvers[typeName] = extract_field_resolvers_from_object_type_1.extractFieldResolversFromObjectType(typeDef);
        }
    }
    return resolvers;
}
exports.extractResolversFromSchema = extractResolversFromSchema;
//# sourceMappingURL=extract-resolvers-from-schema.js.map